<?php
namespace nulib\db\mysql;

use nulib\db\pdo\Pdo;

class Mysql extends Pdo {
  const PREFIX = "mysql";

  static function config_setWaitTimeout(self $mysql): void {
    $mysql->_exec("set session wait_timeout = 28800");
  }
  const CONFIG_setWaitTimeout = [self::class, "config_setWaitTimeout"];

  static function config_unbufferedQueries(self $mysql): void {
    $mysql->db->setAttribute(\PDO::MYSQL_ATTR_USE_BUFFERED_QUERY, false);
  }
  const CONFIG_unbufferedQueries = [self::class, "config_unbufferedQueries"];

  protected const DEFAULT_CONFIG = [
    ...parent::DEFAULT_CONFIG,
    self::CONFIG_setWaitTimeout,
  ];

  function getDbname(): ?string {
    $url = $this->dbconn["name"] ?? null;
    if ($url !== null && preg_match('/^mysql(?::|.*;)dbname=([^;]+)/i', $url, $ms)) {
      return $ms[1];
    }
    return null;
  }
}
